#include <stdlib.h>
#include "pool.h"

/* Pool */

pool_t *alloc_pool(int maxrun) {
  pool_t *p = malloc_check(sizeof(*p)) ;
  p->maxrun = maxrun ;
  p->nrun = 0 ;
  p->waiting = 0 ;
  p->lock = alloc_mutex() ;
  p->cond = alloc_cond() ;  
  return p ;
}

void free_pool(pool_t *p) {
  free_mutex(p->lock) ;
  free_cond(p->cond) ;
  free(p) ;
}

/* To be called by worker: tell pool a worker is free,
   may awake master if suspended */
void leave_pool(pool_t *p) {
  // To complete
}

/* To be called by master: allocate a worker,
   suspend when none is available */
void look_pool(pool_t *p) {
  // To complete
}
